#include "mqttclient.h"
#include "getfuncs.h"

#define VT_PIN A0 
#define AT_PIN A1

  float voltage = 0.0;
  float current = 0.0;
  float watts   = 0.0;

void setup()
{
  analogReadResolution(10); // Setze ADC aufloesung auf 10 bit
  Serial.begin(9600);
  Serial.println(F("[Spannung Strom und Leistung mit MAX471]"));
  // Ethernet / MQTT
  if (MQTTSetup() == false)
  {
    Serial.println("Ethernet Fehler - DHCP nicht erfolgreich");
  }
  else
  {
    Serial.println("- Ethernet aktiviert -");
    PrintIPAddress();
  }

}

void loop()
{
  int vt_read = analogRead(VT_PIN);
  int at_read = analogRead(AT_PIN);

  voltage = (vt_read * 3.5 * 5.0) / 1024.0 ;   // Datenblatt MAX471 Vout = 0 - Vrs+ - 1,5 V  = 3,5V!!!
  current = (at_read * 3.5) / 1024.0;
  watts = voltage * current;
  MQTTConnectAndPublish();                     // Messwerte zum MQTT Server senden
  delay(20000);
}

float Get_Voltage(void)
{
  return(voltage);
}

float Get_Current(void)
{
  return(current);
}

float Get_Watt(void)
{
  return(watts);
}

void PrintIPAddress(void)
{
  Serial.print("Die IP Adresse ist: ");
  for (byte thisbyte = 0; thisbyte < 4; thisbyte++)
  {
    Serial.print(MQTTGetIPAddress(thisbyte),DEC);
    if (thisbyte < 3)
    {
      Serial.print(".");
    }
  }
  Serial.println();
}

