/****************************************************************************
 * Projekt - Messtechnik 1
 * (c) 2017 softwareentwicklung-als-prozess.de
 * Dokumentation s. Blog
 * Funktionalitaet:
 * Aufbau und Nutzung der Verbindung zum MQTT Server
 ***************************************************************************/
// Includes -----------------------------------------------------------------
#include <Ethernet.h>
#include <PubSubClient.h>
#include "mqttclient.h"
#include "getfuncs.h"

// Variablen -----------------------------------------------------------------
static byte mac[] = {0x90, 0xA2, 0xDA, 0x10, 0x4f, 0x46}; // Ethernet MAC Adresse
static IPAddress    pscsrv(192, 168, 198, 25);            // IP Adresse des MQTT Servers
static unsigned int pscport = 1883;                       // MQTT Port

EthernetClient Ether;
PubSubClient pscclient(Ether);

// Funktionen ---------------------------------------------------------------
boolean MQTTSetup(void)
{
  if (Ethernet.begin(mac) == 0) // Fehlerfall
  {
    return(false);
  }
  else
  {
    pscclient.setServer(pscsrv, pscport);
    return(true);
  }
}

byte MQTTGetIPAddress(byte bno)
{
  return(Ethernet.localIP()[bno]);
}

void MQTTConnectAndPublish(void)
{
  char tmpstr[50];
  
  if (pscclient.connect("JGE-TL")) 
  {
    Serial.println("MQTT verbunden");
    // Nach dem connect folgen die Topics
    sprintf(tmpstr,"%6u",(unsigned int)(Get_Voltage() * 1000.0));  // Messwert umwandeln in ASCII String
    pscclient.publish("Sensor3/Spannung/Messwert/mV",tmpstr);
    sprintf(tmpstr,"%6u",(unsigned int)(Get_Current() * 1000.0));  // Messwert umwandeln in ASCII String
    pscclient.publish("Sensor3/Strom/Messwert/mA",tmpstr);
    sprintf(tmpstr,"%6u",(unsigned int)(Get_Watt() * 1000.0));     // Messwert umwandeln in ASCII String
    pscclient.publish("Sensor3/Leistung/Messwert/mW",tmpstr);
  } 
  else 
  {
    Serial.print("MQTT failed, status = ");
    Serial.print(pscclient.state());
    Serial.println();
  }
}


